import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { Fragment, useState } from 'react';
import PropTypes from 'prop-types';
import AppBar from "@material-ui/core/esm/AppBar";
import Tab from "@material-ui/core/esm/Tab";
import Tabs from "@material-ui/core/esm/Tabs";
import useFormApi from "@data-driven-forms/react-form-renderer/use-form-api";

var TabContent = function TabContent(_ref) {
  var name = _ref.name,
      fields = _ref.fields,
      formOptions = _ref.formOptions;
  return /*#__PURE__*/React.createElement(Fragment, {
    key: name
  }, formOptions.renderForm(fields, formOptions));
};

TabContent.propTypes = {
  name: PropTypes.string.isRequired,
  fields: PropTypes.array.isRequired,
  formOptions: PropTypes.shape({
    renderForm: PropTypes.func.isRequired
  }).isRequired
};

var FormTabs = function FormTabs(_ref2) {
  var fields = _ref2.fields,
      AppBarProps = _ref2.AppBarProps,
      TabsProps = _ref2.TabsProps,
      TabProps = _ref2.TabProps;
  var formOptions = useFormApi();

  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      activeTab = _useState2[0],
      setActiveTab = _useState2[1];

  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(AppBar, _extends({
    position: "static"
  }, AppBarProps), /*#__PURE__*/React.createElement(Tabs, _extends({
    value: activeTab,
    onChange: function onChange(_e, tabIndex) {
      return setActiveTab(tabIndex);
    }
  }, TabsProps), fields.map(function (_ref3) {
    var title = _ref3.title,
        name = _ref3.name;
    return /*#__PURE__*/React.createElement(Tab, _extends({
      key: name,
      label: title
    }, TabProps));
  }))), fields.map(function (field, index) {
    return /*#__PURE__*/React.createElement("div", {
      key: field.name,
      hidden: index !== activeTab
    }, /*#__PURE__*/React.createElement(TabContent, _extends({}, field, {
      name: field.name,
      formOptions: formOptions
    })));
  }));
};

FormTabs.propTypes = {
  fields: PropTypes.array.isRequired,
  AppBarProps: PropTypes.object,
  TabsProps: PropTypes.object,
  TabProps: PropTypes.object
};
FormTabs.defaultProps = {
  AppBarProps: {},
  TabsProps: {},
  TabProps: {}
};
export default FormTabs;